/******************************************************
****								VIEWING.C											 ****
**** Preview unter VDI/GDOS												 ****
******************************************************/

/* Geaendert von Thomas Wieschebrink am 23.7.95 	 */
/* Neu an DVI 3.00 angepasst 7.10.95 m. Pristovsek */
/* Nochmal korrigiert von TW am 5.11.95 					 */

#include <vdi.h>
#include <tos.h>

#include <stdlib.h>

#define FALSE 0
#define TRUE 1

#define NO_VDI FALSE	/* TRUE: eigene	Deklarationen	verwenden	*/

/********************************************************************/

#define min(i,j) ((i)<(j)?(i):(j))
long	max_puffer_laenge	=	0;

/********************************************************************/
/* Schreibe in DVI-Datei */

int drucke( char *p, long start_x, long weite, long hoehe, long h_dpi, long v_dpi,
						short fh, short flag, short quer, char *optionen )
{
/* Es wird die Bitmap mit maximaler Auflsung am Bildschirm dargestellt! */
	int		i, hdl, work_in[11], work_out[57], color_index[2], px[8];
	MFDB	bitmap, schirm;

	(void)h_dpi;
	(void)v_dpi;
	(void)start_x;

	if(	 fh>5	 )
	{
		Cconws( "Kann nicht in Dateien drucken!\7" ); /* jedenfalls nicht so */
		return -1;
	}

	if(  flag==4  )
		return 0;	/* Nchste Seite */

	/* Und nun die Ausgabe auf Geraet	21 oder	neue Unit	*/
	work_in[0] = atoi( optionen	);
	/* moegliche VDI-Handles */
	if(	 work_in[0]<=0  )
		work_in[0] = 1;
	for( i = 1;	i	<	10;	i++	)
		work_in[i] = 1;
	work_in[10]	=	2;
	v_opnvwk( work_in,	&hdl,	work_out );
	quer = 1;
	if(	 hdl<=0	 )
	{
		v_opnwk( work_in,	&hdl,	work_out );
		quer = 0;
	}
	if(	 hdl<=0	 )
	{
		Cconws( "Gert lt sich nicht ffnen!\7" );
		return -1;
	}

	bitmap.fd_addr			= p;
	bitmap.fd_w 				= (int)weite;
	bitmap.fd_h 				= (int)hoehe;
	bitmap.fd_wdwidth 	= ((int)weite+15)>>4;
	bitmap.fd_stand 		= 0;
	bitmap.fd_nplanes 	= 1;
	bitmap.fd_r1 = bitmap.fd_r2 = bitmap.fd_r3 = 0;

	schirm.fd_addr			= 0L;
	schirm.fd_w					= 0;
	schirm.fd_h					= 0;
	schirm.fd_wdwidth		= 0;
	schirm.fd_stand			= 0;
	schirm.fd_nplanes		= 0;
	schirm.fd_r1 = schirm.fd_r2 = schirm.fd_r3 = 0;

	Cconws( "\033E" );	/* Bildschirm lschen */
	px[0] = px[1] = 0;
	px[4] = 0;
	if(  Getrez()&~1  )
		px[5] = 16;
	else
		px[5] = 8;
	px[2] = px[6] = (int)min( work_out[0], weite-1 );
	px[3] = px[7] = (int)min( work_out[1]-px[5], hoehe-1 );
	px[7] += px[5];
	

	/* Farbe fuer schwarze Quell-Pixel */
	color_index[0] = 1;
	/* Farbe fuer weisse Quell-Pixel */
	color_index[1] = 0;

	while(  flag&2  )
	{

		/* Bitmap auf (evtl. Farb-)Druckerseite kopieren (1 : REPLACE), *
		 * dabei wird auf dem Zielraster geclippt (laut Doku)!					*/
		vrt_cpyfm( hdl, 1, px, &bitmap, &schirm, color_index );

		/* drucken */
		Cconws( " \033H \033pESC\033q Ende   \033pRET\033q naechste Seite   \033pi\033q hoch   \033pj\033q links   \033pk\033q rechts   \033pm\033q tiefer\033K" );
		i = (int)Cconin();
		switch( i&0xFF )
		{
			case 27			:	/* ESC */
									if(  quer  )
										v_clsvwk( hdl );
									else
										v_clswk( hdl );
									return -1;
			case 13			: /* Enter */
									if(  quer  )
										v_clsvwk( hdl );
									else
										v_clswk( hdl );
									return 0;
			case 'k'		:	/* Cursor rechts */
										px[0] += (px[6]/10)*9;
										if(  px[0]+px[6]>weite  )
											px[0] = (int)weite-px[6];
										px[2] = px[0]+px[6];
									break;
			case 'j'		:	/* Cursor links */
										px[0] -= (px[6]/10)*9;
										if(  px[0]<0  )
											px[0] = 0;
										px[2] = px[0]+px[6];
									break;
			case 'm'		:	/* Cursor runter */
										px[1] += (px[7]/10)*9;
										if(  px[1]+px[7]>hoehe  )
											px[1] = (int)hoehe-px[7]+px[5];
										px[3] = px[1]+px[7];
									break;
			case 'i'		:	/* Cursor hoch */
										px[1] -= (px[7]/10)*9;
										if(  px[1]<0  )
											px[1] = 0;
										px[3] = px[1]+px[7];
									break;
		}
	}
	return 0;
}
/* 12.11.95 */